/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DefaultNamespaceSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings#etag DefaultNamespaceSettings#etag}
    */
    readonly etag?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings#id DefaultNamespaceSettings#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings#setting_name DefaultNamespaceSettings#setting_name}
    */
    readonly settingName?: string;
    /**
    * namespace block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings#namespace DefaultNamespaceSettings#namespace}
    */
    readonly namespace: DefaultNamespaceSettingsNamespace;
}
export interface DefaultNamespaceSettingsNamespace {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings#value DefaultNamespaceSettings#value}
    */
    readonly value?: string;
}
export declare function defaultNamespaceSettingsNamespaceToTerraform(struct?: DefaultNamespaceSettingsNamespaceOutputReference | DefaultNamespaceSettingsNamespace): any;
export declare class DefaultNamespaceSettingsNamespaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DefaultNamespaceSettingsNamespace | undefined;
    set internalValue(value: DefaultNamespaceSettingsNamespace | undefined);
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings databricks_default_namespace_settings}
*/
export declare class DefaultNamespaceSettings extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_default_namespace_settings";
    /**
    * Generates CDKTF code for importing a DefaultNamespaceSettings resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DefaultNamespaceSettings to import
    * @param importFromId The id of the existing DefaultNamespaceSettings that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DefaultNamespaceSettings to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.30.0/docs/resources/default_namespace_settings databricks_default_namespace_settings} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DefaultNamespaceSettingsConfig
    */
    constructor(scope: Construct, id: string, config: DefaultNamespaceSettingsConfig);
    private _etag?;
    get etag(): string;
    set etag(value: string);
    resetEtag(): void;
    get etagInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _settingName?;
    get settingName(): string;
    set settingName(value: string);
    resetSettingName(): void;
    get settingNameInput(): string | undefined;
    private _namespace;
    get namespace(): DefaultNamespaceSettingsNamespaceOutputReference;
    putNamespace(value: DefaultNamespaceSettingsNamespace): void;
    get namespaceInput(): DefaultNamespaceSettingsNamespace | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
